/* poker2.c
 Function: Rs[^Ƒΐ|[J[
 Author: Ken
 Date: 03/09/05
 URL: http://blue.ribbon.to/~kenweb/
 mail: kenweb@s8.xrea.com
*/

#include <stdio.h>
#include<time.h>
#include<stdlib.h>

int yama_card[52];
char *card_mark[]={"Xy[h","n[g","N[o[","_C"};	/*J[h}[NꗗXg*/
char *pare_list[]={NULL,"m[yA","yA","c[yA","X[J[h","Xg[g","tbV","tnEX","tH[J[h","Xg[gtbV","CXg[gtbV"};

typedef struct member {
	int card[5];
	int win;
	char *name;
	int stock[5];
}DATA;

void shuffl(void);	/*RDɃ_ɃJ[h}֐*/
DATA put(int a,DATA arry);	/*D̃J[hRDo֐*/
void show_card(DATA arry);	/*D̃J[h\֐*/
DATA cpu_change(DATA arry,int p);
DATA sort_card(DATA arry);
int pare(DATA arry);		/*D肷֐*/
int winner(DATA arry1,DATA arry2);

int main()
{
	int k,n,change,turn=1,point,p,s,x;
	DATA player[2];
	player[0].name="Ȃ";
	player[1].name="CPU";
	for(k=0;k<5;k++){
		player[0].card[k]=0;
		player[1].card[k]=0;
	}
	
	system("cls");
	
	printf("**************\n");
	printf("|[J[Q[\n");
	printf("**************\n\n");
	shuffl();
	
	for(p=0;p<2;p++){
		for(k=0;k<5;k++)
			player[p]=put(k,player[p]);	/*J[hzz*/
			player[p]=sort_card(player[p]);
			x=pare(player[p]);
		if (p==0) {
				show_card(player[0]);
				printf("F %s\n",pare_list[x]);
		}
		
		else if (p==1) player[1]=cpu_change(player[1],x);
	}
	
	do {		/*J[h*/
			printf("\nJ[h܂H(0-5)\n");
			scanf("%d",&change);
	}
	while((change<0)||(change>5));
	
	if(change==5)
		for(k=0;k<change;k++)
			(player[0].stock[k])=k+1;
	
	else{
		printf("\nԖڂ܂H(J[hNoJ}(,)ŋ؂Ďw)\n");
		printf("jNo1No3No5̃J[hꍇ 1,3,5 Ɠ\n");
		for(k=0;k<change;k++)
			scanf("%d,",&(player[0].stock[k]));
	}
	
	
	for(k=0;k<change;k++)
		player[0]=put((player[0].stock[k])-1,player[0]);
	system("cls");
	
	for(k=0;k<2;k++){
		player[k]=sort_card(player[k]);
		show_card(player[k]);
		x=pare(player[k]);
		printf("F %s\n",pare_list[x]);
	}
	
	winner(player[0],player[1]);
	
	printf("\n^[L[ŏI\n");
	getchar();
	getchar();
	
}

void shuffl(void)	/*RDɃ_ɃJ[h}֐*/
{
	int n,a,p,flg=0;
	srand((unsigned)time(NULL));
	for(n=0;n<52;n++){
		while(flg==0){
			a=rand()%52+1;
			for(p=0;p<=n;p++){
				if(yama_card[p]!=a)	flg=1;
				else {flg=0; break;}
				
			}
		}
		flg=0;
		yama_card[n]=a;
	}
	
}

DATA put(int a,DATA arry)	/*D̃J[hRDo֐*/
{
	int p,tmp,b;
	tmp=arry.card[a];
	arry.card[a]=yama_card[0];
	for(b=0;b<52;b++){
		yama_card[b]=yama_card[b+1];
		if (yama_card[b]==0) {yama_card[b]=tmp; break;}
	}
	return arry;
	
}

DATA sort_card(DATA arry)
{
	int a,b,w;
	for(a=0;a<5;a++){
		for(b=0;b<4-a;b++){
			if((arry.card[b]%13)>(arry.card[b+1]%13)){
				w=arry.card[b];
				arry.card[b]=arry.card[b+1];
				arry.card[b+1]=w;
			}
		}
	}
	return arry;
}


void show_card(DATA arry)	/*D̃J[h\֐*/
{
	int a,s,t;
	printf("\n%s",arry.name);
	printf("D\n");
	printf("No		}[N\n");
	for(a=0;a<5;a++){
		s=(arry.card[a])%13+1;
		t=(arry.card[a])%4;
		printf("(%d)	%d	%s\n",a+1,s,card_mark[t]);
	}
}

int pare(DATA arry)		/*D肷֐*/
{
	int a,b,flash=0,pare=0,straight=0,royal=0;
	for(a=0;a<5;a++){
		if ((arry.card[a]%13+1)==arry.card[a+1]%13) straight++;
		for(b=a+1;b<5;b++){
			if(arry.card[a]%4==arry.card[b]%4)	flash++;
			if((arry.card[a]%13+1)==(arry.card[b]%13+1))	pare++;
		}
	}
	if(((arry.card[4]%13+1==13)&&(arry.card[0]%13+1==1))&&((arry.card[1]%13+1!=2))) {
		straight++;
		royal++;
	}
	
	if (((flash==10)&&(straight==4))&&(royal==1))	return(10);
	if ((flash==10)&&(straight==4))	return(9);
	if (pare==6)	return(8);
	if (pare==4) 	return(7);
	if (flash==10)	return(6);
	if (straight==4)	return(5);
	if (pare==3)	return(4);
	if (pare==2)	return(3);
	if (pare==1)	return(2);
	if (pare==0)	return(1);
}

int winner(DATA arry1,DATA arry2)
{
	printf("\n");
	
	if(pare(arry1)>pare(arry2)){
		printf("Ȃ̏ł\n");
		return 1;
	}
	
	else if (pare(arry1)<pare(arry2)){
		printf("Ȃ̕ł\n");
		return 2;
	}
	
	else {
		printf("ł\n");
		return 0;
	}
}

DATA cpu_change(DATA arry,int p)
{
	int t;
	printf("\n%s",arry.name);
	if(p>=5){
			printf("܂łB\n");
			return arry;
	}
	
	else if(p==4){
		printf("2܂B\n");
		if (((arry.card[3]%13)==(arry.card[2]%13))&&((arry.card[4]%13)==(arry.card[2]%13))){
			arry=put(0,arry);
			arry=put(1,arry);
		}
		
		else if (((arry.card[0]%13)==(arry.card[2]%13))&&((arry.card[1]%13)==(arry.card[2]%13))){
			arry=put(3,arry);
			arry=put(4,arry);
		}
		
		else {
			arry=put(0,arry);
			arry=put(4,arry);
		}
		
		return arry;
	}
	
	else if(p==3){
		printf("1܂B\n");
		if (((arry.card[0]%13)==(arry.card[1]%13))&&((arry.card[4]%13)==(arry.card[3]%13)))
			arry=put(2,arry);
		else if (((arry.card[0]%13)!=(arry.card[1]%13))&&((arry.card[4]%13)==(arry.card[3]%13)))
			arry=put(0,arry);
		else arry=put(4,arry);
		
		return arry;
	}
	
	else if(p==2){
		printf("3܂B\n");
		for(t=0;t<4;t++){
			if((arry.card[t]%13)==(arry.card[t+1]%13)){
				
				if(t==0){
					arry=put(2,arry);
					arry=put(3,arry);
					arry=put(4,arry);
				}
				
				else if(t==1){
					arry=put(0,arry);
					arry=put(3,arry);
					arry=put(4,arry);
				}
				
				else if(t==2){
					arry=put(0,arry);
					arry=put(1,arry);
					arry=put(4,arry);
				}
				
				else {
					arry=put(0,arry);
					arry=put(1,arry);
					arry=put(2,arry);
				}
			}
		}
		return arry;
	}
	
	else if(p==1){
		printf("SČ܂B\n");
		for(t=0;t<5;t++)
			arry=put(t,arry);
		return arry;
	}
}


